package cerebral;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import cytoscape.Cytoscape;
import cytoscape.data.CyAttributes;

public class NetworksManager {
    
    private Map expressionAttributes = new HashMap();
    private Map cerebralViews = new HashMap();
    
    private final String DELIM = "=";


    private static NetworksManager networksManager = new NetworksManager();

    public static NetworksManager instance() {
        return networksManager;
    }

    private NetworksManager() {
     
    }
    
    public void addCerebralView (String networkID, Cerebral view){
        cerebralViews.put(networkID, view);        
    }
    public void removeCerebralView (String networkID){
        cerebralViews.remove(networkID);        
    }
    
    public Cerebral getCerebralView (String networkID){
        return (Cerebral) cerebralViews.get(networkID);
    }
    
    
    public void setExpressionAttributes (String networkID, List ea){
        expressionAttributes.put(networkID, ea);
    }
    
    public List getExpressionAttributes (String networkID){
        return (List)expressionAttributes.get(networkID);
    }
    
    public void loadAttributeSelection(String networkIdentifier){
        List attributes = new ArrayList();
        CyAttributes globalAttributes = Cytoscape.getNetworkAttributes();
        String loadString = globalAttributes.getStringAttribute(networkIdentifier, "cerebralPCAttributes");
        if (loadString != null && !loadString.equals("")) {
               String[] vals = loadString.split(DELIM);
               for (int i=0; i < vals.length; i++){
                   attributes.add(vals[i]);
               }
        }
        
        setExpressionAttributes(networkIdentifier, attributes);
    }
	
}
