package cerebral.colors;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;

import prefuse.util.ColorLib;

public class ColorLegend extends JPanel {
    private static final long serialVersionUID = 1L;
    ColorScaleBar csb;
	public ColorLegend(ColorRange head) {
		setLayout(new GridBagLayout());
		setPreferredSize(new Dimension(100,35));
		setMinimumSize(new Dimension(100,35));
		setColorScale(head);
		setBackground(Color.white);
	}

	public void setColorScale(ColorRange head){
		removeAll();
		GridBagConstraints c = new GridBagConstraints();
		c.gridx = 0;
		c.gridy = 0;
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1.0;
		c.weighty = 1.0;
		csb = new ColorScaleBar(head);
		add(csb, c);
		c.gridy = 1;
		add(new ColorScaleLabels(head), c);		
	}
	
	public ColorScaleBar getColorScaleBar(){
	    return csb;
	}
	
	public void update(){
		csb.relayout();
		repaint();	
	
	}
	public static void main(String[] args) {
		// Schedule a job for the event-dispatching thread:
		// creating and showing this application's GUI.
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				// Make sure we have nice window decorations.
				JFrame.setDefaultLookAndFeelDecorated(true);

				// Create and set up the window.
				JFrame frame = new JFrame("test");
				frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

				
				ColorRange head = new ConstantRange(-5.0,  null, ColorLib.rgb(255,0,0));
				ColorRange next = new ConstantRange(-3.0,  head, ColorLib.rgb(0,255,0));
				ColorRange n1 = new ConstantRange(-2.0,  next, ColorLib.rgb(0,0,255));
				ColorRange n2 = new ConstantRange(1.0,  n1, ColorLib.rgb(255,0,255));
				ColorRange terminator = new TerminateRange(7.0, n2);				
				
				
				/*
				cs.addRange(new LinearRange(-5.0, -4.0, ColorLib.rgb(255, 0, 0),
						ColorLib.rgb(32, 0, 0)));
				cs.addRange(new ConstantRange(-4.0, -3.0, ColorLib.rgb(255,0,0)));
				cs.addRange(new SigmoidalRange(-3.0, -2.0, ColorLib.rgb(255,0,00)));

				cs.addRange(new LinearRange(-2.0, -1.0, ColorLib.rgb(0, 255, 0),
						ColorLib.rgb(0, 32, 0)));
				cs.addRange(new ConstantRange(-1.0, 0.0, ColorLib.rgb(0,255,0)));
				cs.addRange(new SigmoidalRange(0.0, 1.0, ColorLib.rgb(0,255,0)));
				  */
				
				ColorLegend csb = new ColorLegend(head);
				csb.setOpaque(true); // content panes must be opaque
				frame.setContentPane(csb);

				// Display the window.
				frame.pack();
				frame.setVisible(true);
			}
		});
	}
}
