package cerebral.colors;

import javax.swing.JComponent;

public abstract  class ColorRangeComponent extends JComponent implements
		ColorRange{
	 
	double min;
	ColorRange lowerRange;
	ColorRange higherRange = null;

	public ColorRangeComponent(double min, ColorRange lowerRange){
		this.min =min;
		this.lowerRange = lowerRange;
		if (lowerRange!= null){
			ColorRangeComponent lr = (ColorRangeComponent)lowerRange;
			lr.higherRange = this;
		}	
	}

	public double getRange(){
		return higherRange.getMin() - min;
	}

	public double getMin(){
		return min;
	}
	public void setMin(double newMin){
		min = newMin;
	}
	public boolean isInRange(double val) {
		return val >= min && val < higherRange.getMin();		
	}	
	
	public ColorRange next(){
		return higherRange;
	}
	public ColorRange prev(){
		return lowerRange;
	}

	}
	

