package cerebral.parallelCoordinates.controls;

import java.awt.event.MouseEvent;

import javax.swing.ToolTipManager;

import prefuse.Display;
import prefuse.controls.ControlAdapter;
import prefuse.visual.VisualItem;
import cerebral.parallelCoordinates.ParallelCoordinates;

public class DataToolTip extends ControlAdapter {
	private ParallelCoordinates PC;
	public DataToolTip(ParallelCoordinates PC) {
        this.PC = PC;
		ToolTipManager.sharedInstance().setInitialDelay(0);
	}

	public void itemEntered(VisualItem item, MouseEvent e) {
		if (item.isInGroup(ParallelCoordinates.DATA)) {
			Display d = (Display) e.getSource();
			d.setToolTipText(item.getString(ParallelCoordinates.LABEL));
            item.setHover(true);
            d.getVisualization().run("color");
            d.getVisualization().run("repaint");
            PC.fireEvent("hover", null,item.getString(ParallelCoordinates.LABEL));    
		}
	}

	public void itemExited(VisualItem item, MouseEvent e) {
		if (item.isInGroup(ParallelCoordinates.DATA)) {
			Display d = (Display) e.getSource();
			d.setToolTipText(null);		
            item.setHover(false);
            d.getVisualization().run("color");
            d.getVisualization().run("repaint");            
            PC.fireEvent("hover", null, null);
		}
	}

}
